var fs = require('fs');
var path = require('path');
var template = fs.readFileSync(path.resolve(__dirname, './async-template'), { encoding: 'utf8' });

module.exports = function (content) {
    var rasync = /\brequire\.async\(([^)]+)\)/g;
    var matched = content.match(rasync);

    if (matched) {
        var rsinglelineComment = /\/\/.*(?:[\n\r]|$)/g;
        var rmultilineComment = /\/\s*\*(?:(?!(\*\s*\/)).|[\n\r])*(?:\*\s*\/)/g;
        var replaceholder = 'This_is_a_comment_replace_holder_and_I_want_it_to_be_unique_';
        var getReplaceholder = function(index) { return '## ' + replaceholder + index + ' ##' };
        var rholder = new RegExp('## ' + replaceholder + '(\\d+) ##', 'g')
        var i = 0;
        var comments = [];

        var contentWithoutMultipleLineComment = content.replace(rmultilineComment, function(matched) {
            comments[i] = matched;
            return getReplaceholder(i++);
        });

        var contentWithoutSingleLineComment = contentWithoutMultipleLineComment.replace(rsinglelineComment, function(matched) {
            comments[i] = matched;
            return getReplaceholder(i++);
        });

        var replacedContent = contentWithoutSingleLineComment.replace(rasync, function(asyncRequire, filePath) {
            return template.replace(/\$FILE_PATH\$/g, filePath)
        });

        return replacedContent.replace(rholder, function(_, index) {
            return comments[+index];
        });
    }

    return content;
}
