/**
 * js预处理，从js中删除scss/css文件的引用
 * @author yuhao.ju
 */
var fs = require('fs');
var path = require('path');
var exists = require('exists-case');

module.exports = function (content) {
    if (this.resourcePath.search('node_modules') === -1
        || this.resourcePath.search(/(@qnpm\/)?yo3?/) !== -1) {
        // 匹配 @import "path/xxxx";
        var self = this;
        content = content.replace(/(import\s.*)|(require\(.*\))/g, function (importStatement) {
            // 匹配 "path/xxxx";
            var replacedImportStatement = importStatement.replace(/['"]([^'"]+)['"]/g, function (match, modulePath) {
                var extname = path.extname(modulePath);
                var sassResolvePath = '';

                // 寻找不带后缀引用的 scss 文件, sass文件和css文件
                if (extname === '') {
                    var possibleScssPath = path.resolve(self.context, modulePath + ".scss");
                    var possibleCssPath = path.resolve(self.context, modulePath + ".css");
                    if ((fileExists(possibleScssPath) || fileExists(possibleCssPath))
                        && !fileExists(path.resolve(self.context, modulePath + '.js'))) {
                        sassResolvePath = path.resolve(self.context, modulePath)
                    }
                }

                // 寻找 .sass 和 .scss 文件和.css文件
                if (extname === '.scss' || extname === '.css') {
                    var alternative;
                    if (extname === '.scss') {
                        alternative = modulePath.replace(/([^\/]+\.scss)$/, '_$1');
                    }
                    if (fileExists(path.resolve(self.context, modulePath))) {
                        sassResolvePath = path.resolve(self.context, modulePath);
                    }
                    if (alternative && fileExists(path.resolve(self.context, alternative))) {
                        sassResolvePath = path.resolve(self.context, alternative);
                    }
                }

                // 将引用语句从原 js 移到 sass 入口文件中
                if (sassResolvePath) {
                    return 'removedScssPath';
                } else {
                    return match;
                }
            });

            // 如果发现有引入 sass 的语句，删除它
            if (replacedImportStatement.indexOf('removedScssPath') > -1) {
                return ''
            } else {
                return importStatement;
            }
        })
    }

    return content;
};

function fileExists(filepath) {
    try {
        return filepath && exists.sync(filepath);
    } catch (err) {
        return false;
    }
}