var path = require('path')
var fs = require('fs')
var swUtil = require('./util')
var appRootPath = __dirname.split('node_modules')[0]

var NPM_REGISTRY = 'registry.npmjs.org'

// 如果有 yarn.lock 则不做任何处理
if (fs.existsSync(path.join(process.cwd(), 'yarn.lock'))) {
    return
}

swUtil.handlePeerDepRecursive(path.resolve(appRootPath, './node_modules'))

var swPath = path.resolve(appRootPath, './npm-shrinkwrap.json')
if(swUtil.fileExists(swPath)) {
    // 存储原有内容
    var originSwContent = fs.readFileSync(swPath, {encoding: 'utf8'})

    // 重新生成 sw
    swUtil.createShrinkwrap({silent: true})

    if(fs.readFileSync(swPath, {encoding: 'utf8'}) !== originSwContent) {
        // 恢复原有内容
        fs.writeFileSync(swPath, originSwContent)

        swUtil.logWarn('\n[Ykit] npm-shrinkwrap.json 可能需要更新，建议重新执行 ykit sw')
    } else if(originSwContent.indexOf(NPM_REGISTRY) > -1) {
        swUtil.logWarn('\n[Ykit] npm-shrinkwrap.json 中有 ' + NPM_REGISTRY + ' 为源的包，可能会影响安装速度.')
    }
} else {
    swUtil.logWarn('\n[Ykit] npm-shrinkwrap.json 不存在，构建存在风险，建议执行 ykit sw 生成')
}

swUtil.recoverPeerDepRecursive(path.resolve(appRootPath, './node_modules'))
