import 'babel-polyfill';
import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import '@qnpm/hysdk'; // 用来适配大客户端和微信，如果不需要可以去掉
import { Router, Route, IndexRoute, Link } from '$router';
import HomePage from './home';
import yoHistory from '../../common/history';

const List = require.async('./list');
const Detail = require.async('./detail');

// 配置 hy 里 native header
const nav = (text, right) => {
    const result = {
        title: { text, style: 'text' }
    }
    if (right) result.right = { text: right, style: 'text' }
    return result
}

const Root = () => (
    <Router history={yoHistory}>
        {/* navigation 是配置 hy 里 native header 的属性 */}
        <Route path="/" navigation={nav('首页')}>
            <IndexRoute component={HomePage}/>
            <Route path="list" getComponent={List} navigation={nav('列表页', '点我')} />
            <Route path="detail" getComponent={Detail} navigation={nav('详情页')} />
        </Route>
    </Router>
);

ReactDOM.render(<Root />, document.getElementById('root'));
